Codeforces C. Boboniu and Bit Operations(按位或者状压)

2024-04-16 00:18

本文主要是介绍Codeforces C. Boboniu and Bit Operations(按位或者状压),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Boboniu likes bit operations. He wants to play a game with you.

Boboniu gives you two sequences of non-negative integers 𝑎1,𝑎2,…,𝑎𝑛 and 𝑏1,𝑏2,…,𝑏𝑚.

For each 𝑖 (1≤𝑖≤𝑛), you’re asked to choose a 𝑗 (1≤𝑗≤𝑚) and let 𝑐𝑖=𝑎𝑖&𝑏𝑗, where & denotes the bitwise AND operation. Note that you can pick the same 𝑗 for different 𝑖’s.

Find the minimum possible 𝑐1|𝑐2|…|𝑐𝑛, where | denotes the bitwise OR operation.

Input
The first line contains two integers 𝑛 and 𝑚 (1≤𝑛,𝑚≤200).

The next line contains 𝑛 integers 𝑎1,𝑎2,…,𝑎𝑛 (0≤𝑎𝑖<29).

The next line contains 𝑚 integers 𝑏1,𝑏2,…,𝑏𝑚 (0≤𝑏𝑖<29).

Output
Print one integer: the minimum possible 𝑐1|𝑐2|…|𝑐𝑛.

Examples
inputCopy
4 2
2 6 4 0
2 4
outputCopy
2
inputCopy
7 6
1 9 1 9 8 1 0
1 1 4 5 1 4
outputCopy
0
inputCopy
8 5
179 261 432 162 82 43 10 38
379 357 202 184 197
outputCopy
147
Note
For the first example, we have 𝑐1=𝑎1&𝑏2=0, 𝑐2=𝑎2&𝑏1=2, 𝑐3=𝑎3&𝑏1=0, 𝑐4=𝑎4&𝑏1=0.Thus 𝑐1|𝑐2|𝑐3|𝑐4=2, and this is the minimal answer we can get.

题意:
c[i]=a[i]&b[j],j可以任意取。
求c[1]|c[2]|…|c[n-1]|c[n]的最小值

思路:
看错数据范围了,看成了 1 0 9 10^9 109。如果是题意的 2 9 2^9 29,那就可以直接状压,枚举c[n]能变成多少个数,最后取最小的即可。因为最多500个数,所以复杂度为O(n^2*500)。

但是也可以直接按位搞,这个方法甚至可以应对1e18。

就是先考虑二进制最高位1,如果有一个c[i]不得不取二进制第i位为1,则这一个二进制位必须要。否则把所有二进制第i位为1的数筛掉,这一位可以不取。复杂度为O(n^2*log(n))

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <iostream>
#include <map>
#include <string>
#include <set>typedef long long ll;
using namespace std;const int maxn = 205;
int a[maxn],b[maxn];
vector<int>C[maxn];
int n,m;void Clear(int pos,int n) {for(int i = 1;i <= n;i++) {vector<int>tmp;for(int j = 0;j < C[i].size();j++) {int v = C[i][j];if((v & (1 << pos)) == 0) {tmp.push_back(v);}}C[i].clear();C[i] = tmp;}
}int main() {scanf("%d%d",&n,&m);for(int i = 1;i <= n;i++) {scanf("%d",&a[i]);}for(int i = 1;i <= m;i++) {scanf("%d",&b[i]);}for(int i = 1;i <= n;i++) {for(int j = 1;j <= m;j++) {C[i].push_back(a[i] & b[j]);}}ll ans = 0;for(int i = 30;i >= 0;i--) {int cnt = 0;for(int j = 1;j <= n;j++) {int flag = 0;vector<int>tmp;for(int k = 0;k < C[j].size();k++) { //只要有一个第i位为0,则合理int v = C[j][k];if((v & (1 << i)) == 0) flag = 1;}if(flag) cnt++;}if(cnt == n) { //全部都可以抽出第i位为0,则所有第i位为1的数删掉Clear(i,n);} else {ans |= (1 << i); //抽不出来,则必须算上第i位。}}printf("%lld\n",ans);return 0;
}

这篇关于Codeforces C. Boboniu and Bit Operations(按位或者状压)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/907318

相关文章

Linux使用粘滞位 (t-bit)共享文件的方法教程

《Linux使用粘滞位(t-bit)共享文件的方法教程》在Linux系统中,共享文件是日常管理和协作中的常见任务,而粘滞位(StickyBit或t-bit)是实现共享目录安全性的重要工具之一,本文将... 目录文件共享的常见场景基础概念linux 文件权限粘滞位 (Sticky Bit)设置共享目录并配置粘

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

[论文笔记]LLM.int8(): 8-bit Matrix Multiplication for Transformers at Scale

引言 今天带来第一篇量化论文LLM.int8(): 8-bit Matrix Multiplication for Transformers at Scale笔记。 为了简单,下文中以翻译的口吻记录,比如替换"作者"为"我们"。 大语言模型已被广泛采用,但推理时需要大量的GPU内存。我们开发了一种Int8矩阵乘法的过程,用于Transformer中的前馈和注意力投影层,这可以将推理所需

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

Codeforces#295(Div.2)A、B(模拟+BFS)

解题报告链接:点击打开链接 C. 题目链接:点击打开链接 解题思路: 对于给定的字符串,取出现次数最多的字母(可以同时有多个)。由这些字母组成长度为n的字符串,求有多少种组合。最后用数学知识即可。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <climits>

Codeforces Round #281 (Div. 2)A(构造+暴力模拟)

题目链接:http://codeforces.com/problemset/problem/493/A 解题思路: 暴力的判断,分三种情况去判断即可。注意如果之前已经被罚下场后,那么在后面的罚下情况不应该算在输出结果内。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <co